#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum BigQueryType {
    #[serde(rename = "DOUBLE")]
    Double,
    #[serde(rename = "STRING")]
    String,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl BigQueryType {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            BigQueryType::Double => "DOUBLE",
            BigQueryType::String => "STRING",
            BigQueryType::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for BigQueryType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for BigQueryType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for BigQueryType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(v: &str) -> Result<BigQueryType, conjure_object::plain::ParseEnumError> {
        match v {
            "DOUBLE" => Ok(BigQueryType::Double),
            "STRING" => Ok(BigQueryType::String),
            v => v.parse().map(|v| BigQueryType::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for BigQueryType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<BigQueryType, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the BigQueryType enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
